## deal.ii 6.3.1

=== Makefile ===
# $Id: Makefile 18944 2009-06-22 05:24:02Z young $
#
# Makefile for the whole library

# include global options and pathes. there's one exception where we don't want
# that, namely for build tests: in that case, the makefile is called before we
# have even run ./configure, so we can't include this file, but the target
# then called doesn't need the variables defined in there doesn't need them
# anyway and calls ./configure first
ifneq ($(BUILDTEST),yes)
  include common/Make.global_options
endif


help:
	@echo "========================================================================"
	@echo "=              Global Makefile for the deal.II libraries               ="
	@echo "========================================================================"
	@echo "=                                                                      ="
	@echo "= The following targets exist:                                         ="
	@echo "=    baseg lacg : debug libraries \"base\" and \"lac\"                     ="
	@echo "=    baseo laco : optimized libraries \"base\" and \"lac\"                 ="
	@echo "=    base lac   : debug and optimized libraries \"base\" and \"lac\"       ="
	@echo "=    1dg 2dg 3dg: deal.II debug version for specified dimension        ="
	@echo "=    1do 2do 3do: deal.II optimized version for specified dimension    ="
	@echo "=    1d 2d 3d   : deal.II debug and optimized for specified dimension  ="
	@echo "=                                                                      ="
	@echo "=    contrib    : additional libraries in contrib, if there are any    ="
	@echo "=                                                                      ="
	@echo "=    all        : base, lac, 1d, 2d and 3d, contrib                    ="
	@echo "=    debug      : baseg, lacg, 1dg, 2dg and 3dg, contrib               ="
	@echo "=    optimized  : baseo, laco, 1do, 2do and 3do, contrib               ="
	@echo "=                                                                      ="
	@echo "=    online-doc : generate the documentation in HTML format            ="
	@echo "=    TODO       : create a \"TODO\" file from the source files           ="
	@echo "=    TAGS       : create a TAGS file from include and source files     ="
	@echo "=                                                                      ="
	@echo "=    clean      : removes all object files in subdirs                  ="
	@echo "=    distclean  : removes all object files, libraries, etc in subdirs  ="
	@echo "========================================================================"


common/scripts/make_dependencies:
	cd $D/common/scripts && $(MAKE) $(MAKEOPTIONS) make_dependencies

common/scripts/expand_instantiations:
	cd $D/common/scripts && $(MAKE) $(MAKEOPTIONS) expand_instantiations

deps: common/scripts/make_dependencies common/scripts/expand_instantiations
	cd $D/base && $(MAKE) $(MAKEOPTIONS) Makefile.dep
	cd $D/lac && $(MAKE) $(MAKEOPTIONS) Makefile.dep
	cd $D/deal.II && $(MAKE) $(MAKEOPTIONS) Makefile.dep
	cd $D/lib && $(MAKE) $(MAKEOPTIONS) external-links

baseg: deps contrib
	cd $D/base && $(MAKE) $(MAKEOPTIONS) libg

baseo: deps contrib
	cd $D/base && $(MAKE) $(MAKEOPTIONS) libo

lacg: deps baseg
	cd $D/lac && $(MAKE) $(MAKEOPTIONS) libg

laco: deps baseo
	cd $D/lac && $(MAKE) $(MAKEOPTIONS) libo

1dg: deps baseg lacg
	cd $D/deal.II && $(MAKE) $(MAKEOPTIONS) 1dg

2dg: deps baseg lacg
	cd $D/deal.II && $(MAKE) $(MAKEOPTIONS) 2dg

3dg: deps baseg lacg
	cd $D/deal.II && $(MAKE) $(MAKEOPTIONS) 3dg

1do: deps baseo laco
	cd $D/deal.II && $(MAKE) $(MAKEOPTIONS) 1d

2do: deps baseo laco
	cd $D/deal.II && $(MAKE) $(MAKEOPTIONS) 2d

3do: deps baseo laco
	cd $D/deal.II && $(MAKE) $(MAKEOPTIONS) 3d


base: baseg baseo
lac: lacg laco
1d: 1dg 1do
2d: 2dg 2do
3d: 3dg 3do

$(LIBDIR):
	@mkdir $@

baseg baseo base lacg laco lac 1dg 1do 1d 2dg 2do 2d 3dg 3do 3d all debug contrib functionparser : $(LIBDIR) deps

all: debug optimized
debug: contrib baseg lacg 2dg 1dg 3dg
optimized: contrib baseo laco 2do 1do 3do


# when HSL functions are used, we also compile the detached_ma27
# program which itself uses the optimized base library; so add this to
# the dependencies if necessary
#
# make sure the function parser is also built (it isn't in the default
# build list of the subdirectory, since it needs to be built before
# libbase
contrib: contrib-functionparser
	cd $D/contrib && $(MAKE)

contrib-functionparser:
	@cd $D/contrib && $(MAKE) functionparser

online-doc doc:
	cd $D/doc && $(MAKE)
	@echo
	@echo
	@echo =======================================================
	@echo "The online documentation can now be accessed through"
	@echo "  $D/doc/index.html"
	@echo =======================================================
	@echo
	@echo

TODO:
	@egrep -i '// *todo' $D/base/include/*/*.h $D/base/source/*.cc \
                     $D/lac/include/*/*.h $D/lac/source/*.cc   \
                     $D/deal.II/include/*/*.h $D/deal.II/source/*/*.cc \
	| perl -pi -e 's#$D/?#\n#;' \
	| perl -pi -e 's#(.*)(TODO:?)(\[[^\]]+\])?#\3 \1\2\3#i;' \
	| perl -pi -e 's#\s*//\s*TODO:?\s*(\[[^\]]+\])?:?\s*#\n\1     #i;' \
             > $@


TAGS:
	@cd $D/common ; etags --language=c++ \
	$D/base/include/*/*.h $D/lac/include/*/*.h $D/deal.II/include/*/*.h \
	$D/base/source/*.cc $D/lac/source/*.cc \
	$D/deal.II/source/*/*.cc $D/deal.II/source/*/*.h \
	$D/examples/*/*.cc ; \
	perl -pi -e 's/ \* .*//g; s&[\t]*/\*.*&&g; s&[\t]*\*/.*&&g;' TAGS


clean: deps \
       clean-contrib clean-base clean-lac clean-dealII \
       clean-doc clean-examples clean-lib clean-tests
	-rm -f TODO common/TAGS

clean-contrib:
	cd $D/contrib && $(MAKE) clean

clean-base:
	cd $D/base && $(MAKE) clean

clean-lac:
	cd $D/lac && $(MAKE) clean

clean-dealII:
	cd $D/deal.II && $(MAKE) clean

clean-doc:
	cd $D/doc && $(MAKE) clean

clean-examples:
	cd $D/examples && $(MAKE) clean

clean-lib:
	cd $D/lib && $(MAKE) clean

# if that directory exists, go into 'tests' and clean up there as well
clean-tests:
	-cd tests && $(MAKE) clean

clean-common-scripts:
	cd $D/common/scripts && $(MAKE) clean

distclean: clean
	cd lib && $(MAKE) distclean
	-cd tests && $(MAKE) distclean
	-rm base/source/*.inst lac/source/*.inst deal.II/source/*/*.inst
	$(MAKE)	clean-common-scripts



# #############################################################################
# targets for build tests. these targets are supposed to be called for regular
# build tests that send their results back home to our build test server. note
# that this target is supposed to be called right after checking out a version
# from our CVS server, so at this time, common/Make.global_options doesn't
# exist yet (and isn't included at the top of this file, due to a
# conditional), and we first have to set up all this stuff.
#
# the way this target works is that it first generates a bunch of lines for
# the output file that will ultimately be sent home. it then calls ./configure
# and stashes away both the output and the return value. if ./configure
# succeeds, we extract a little more information concluding the
# header. irrespective of this, we then append the output of ./configure to
# the log file. if the call to ./configure failed, we send the result back
# home and exit.
#
# if ./configure succeeded, we then go on to the build-test-do target, which
# actually compiles something, and when we come back from there we send the
# whole thing over to the server
build-test:
	echo AUTOMATED DEAL.II BUILD TEST          | tee    build-test-log
	echo SUBVERSION INFO `svn info . | grep Revision` | tee -a build-test-log
	echo BEGIN HEADER `date -u '+%Y-%m-%d %T'`        | tee -a build-test-log
	echo USER=$(USER)                          | tee -a build-test-log
	echo HOST=`hostname`                       | tee -a build-test-log
	echo BUILDTESTFLAGS=$(BUILDTESTFLAGS)      | tee -a build-test-log
	echo BUILDTESTNOTE=$(BUILDTESTNOTE)        | tee -a build-test-log
	-(./configure $(BUILDTESTFLAGS) 2>&1) > build-test-config
	if test -f common/Make.global_options ; then \
	   grep '^enable-shared' common/Make.global_options | grep = ; \
	   grep enable-threads common/Make.global_options | grep = ; \
	   grep USE_CONTRIB_PETSC common/Make.global_options | grep = ; \
	   grep USE_CONTRIB_SLEPC common/Make.global_options | grep = ; \
	   grep USE_CONTRIB_METIS common/Make.global_options | grep = ; \
	   grep USE_CONTRIB_HSL common/Make.global_options | grep = ; \
	   grep USE_CONTRIB_UMFPACK common/Make.global_options | grep = ; \
	 fi    | tee -a build-test-log
	echo END HEADER `date -u '+%Y-%m-%d %T'`             | tee -a build-test-log
	echo                                  | tee -a build-test-log
	echo BEGIN CONFIGURE OUTPUT `date -u '+%Y-%m-%d %T'` | tee -a build-test-log
	cat build-test-config                 | tee -a build-test-log
	echo END CONFIGURE OUTPUT `date -u '+%Y-%m-%d %T'`   | tee -a build-test-log
	echo                                  | tee -a build-test-log
	-$(MAKE) BUILDTEST= build-test-do 2>&1 | tee -a build-test-log

# target to do the actual compilation tests for an automated build test. build
# the library, the example programs, and the doxygen example programs. if the
# testsuite has been checked out, run that, too, and send the results to the
# testsuite server
build-test-do:
	@echo BEGIN MAKE LIB OUTPUT `date -u '+%Y-%m-%d %T'`
	$(MAKE) all
	@echo END MAKE LIB OUTPUT `date -u '+%Y-%m-%d %T'`
	@echo 
	@echo BEGIN MAKE EXAMPLES OUTPUT `date -u '+%Y-%m-%d %T'`
	cd examples ; $(MAKE)
	@echo END MAKE EXAMPLES OUTPUT `date -u '+%Y-%m-%d %T'`
	@echo 
	@echo BEGIN MAKE DOXYGENTUTORIALS OUTPUT `date -u '+%Y-%m-%d %T'`
	cd examples/doxygen ; $(MAKE)
	@echo END MAKE DOXYGENTUTORIALS OUTPUT `date -u '+%Y-%m-%d %T'`
	@echo 
#	if test -d tests ; then \
#	   @echo BEGIN MAKE TESTS OUTPUT `date -u '+%Y-%m-%d %T'` ; \
#	   cd tests ; $(MAKE) report+mail ; \
#	   @echo END MAKE TESTS OUTPUT `date -u '+%Y-%m-%d %T'` ; \
#	   @echo ; \
#	 fi
	@echo BUILD TEST SUCCESSFUL `date -u '+%Y-%m-%d %T'`


.PHONY: base baseg lac lacg 1d 2d 3d 1dg 2dg 3dg all \
        online-doc doc printable-doc tex-doc contrib \
        clean clean-contrib clean-base clean-lac clean-dealII \
	clean-doc clean-examples clean-lib clean-tests clean-common-scripts \
	distclean \
	build-test build-test-do \
	TAGS TODO

# mark the following two as phony since they mark two actual files but
# we don't want to list the full dependencies here. let the sub-makefiles
# do that
.PHONY: common/scripts/make_dependencies \
        common/scripts/expand_instantiations

=== base/Makefile ===
# $Id: Makefile 20992 2010-04-15 15:21:15Z bangerth $
# Copyright W. Bangerth, University of Heidelberg, 1998, 1999, 2000, 2001, 2002



# deal.II top level directory
D=..


# create lists of file names
cc-files     = $(shell echo $D/base/source/*.cc)
o-files-base = $(addprefix $(LIBDIR)/base/, $(patsubst $D/base/source/%,%,$(cc-files:.cc=.$(OBJEXT))))
o-files      = $(sort $(o-files-base))
go-files     = $(o-files:.$(OBJEXT)=.g.$(OBJEXT))
h-files      = $(sort $(shell echo include/base/*.h))

# get options which hold for all files of the project
include $D/common/Make.global_options


# there's an extra .o file for the function parser that we need to link into
# libbase. do similarly for the threading building block things if threading
# is enabled
ifeq ($(enable-parser),yes)
  extra-o-files  = $(LIBDIR)/contrib/functionparser/fparser.$(OBJEXT)
  extra-g.o-files = $(LIBDIR)/contrib/functionparser/fparser.$(OBJEXT)
endif

# production rules
$(LIBDIR)/base/%.g.$(OBJEXT) :
	@echo "=====base=============debug======$(MT)== $(<F)"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
$(LIBDIR)/base/%.$(OBJEXT) :
	@echo "=====base=============optimized==$(MT)== $(<F)"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@


# in general, when linking shared libraries, we will want to link with
# the underlying libs as well. AIX even requires this. on the other
# hand, on DEC OSF with CXX this will fail with duplicate symbols, so
# make sure that it doesn't happen on that system and that compiler
#
# for the current directory, this is only the PETSc libraries since we
# reference them in base/source/utilities
ifneq ($(GXX-VERSION),compaq_cxx)
  deplibs.g =
  deplibs.o =

  ifeq ($(USE_CONTRIB_PETSC),yes)
    deplibs.g += $(lib-contrib-petsc.g) $(DEAL_II_PETSC_MPIUNI_LIB)
    deplibs.o += $(lib-contrib-petsc.o) $(DEAL_II_PETSC_MPIUNI_LIB)
  endif

  ifeq ($(USE_CONTRIB_TRILINOS),yes)
    deplibs.g += $(lib-contrib-trilinos)
    deplibs.o += $(lib-contrib-trilinos)
  endif

  ifeq ($(enable-threads),yes)
    deplibs.g += $D/lib/libtbb_debug$(shared-lib-suffix)
    deplibs.o += $D/lib/libtbb$(shared-lib-suffix)
  endif

else
  deplibs.g =
  deplibs.o =
endif


# rules for libraries
lib: $(LIBDIR)/libbase.g$(lib-suffix) $(LIBDIR)/libbase$(lib-suffix)
libg: $(LIBDIR)/libbase.g$(lib-suffix)
libo: $(LIBDIR)/libbase$(lib-suffix)

$(LIBDIR)/libbase$(static-lib-suffix): $(o-files)
	@echo "=====base=============optimized==$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(o-files) $(extra-o-files)
	@$(RANLIB) $@

$(LIBDIR)/libbase.g$(static-lib-suffix): $(go-files)
	@echo "=====base=============debug======$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(go-files) $(extra-g.o-files)
	@$(RANLIB) $@


$(LIBDIR)/libbase$(shared-lib-suffix): $(o-files)
	@echo "=====base=============optimized==$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,base) $(call DEAL_II_ADD_SONAME,base) $(o-files) $(extra-o-files)  $(deplibs.o)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,base) $@

$(LIBDIR)/libbase.g$(shared-lib-suffix): $(go-files)
	@echo "=====base=============debug======$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,base.g) $(call DEAL_II_ADD_SONAME,base.g) $(go-files) $(extra-g.o-files)  $(deplibs.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,base.g) $@




clean:
	-rm -f *~ include/*~ include/*/*~ Makefile.dep source/*.inst


# Rule to generate the dependency file. This file is
# automagically remade whenever needed, i.e. whenever
# one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom
# of this file.
#
# If the command fails, then remove Makefile.dep again and fail
Makefile.dep: $(cc-files) $(h-files) Makefile $D/common/Make.global_options
	@echo ============================ Remaking base/Makefile
	@$D/common/scripts/make_dependencies $(INCLUDE) "-B$(LIBDIR)/base" $(cc-files) \
		> $@ \
	 || (rm -f $@ ; false)



# include all the dependencies
include Makefile.dep

.PHONY: clean
.PHONY: lib lib$(static-lib-suffix) lib.g$(static-lib-suffix)

=== deal.II/Makefile ===
# $Id: Makefile 21470 2010-07-11 23:20:30Z bangerth $
# Copyright W. Bangerth, University of Heidelberg, 1998, 1999, 2000, 2001, 2002


# deal.II top level directory
D=..


# get options which hold for all files of the project
include $D/common/Make.global_options



# top level targets
default: 2dg 2d
all: 2dg 2d 3dg 3d 1dg 1d
debug: 2dg 3dg 1dg


1dg: $(LIBDIR)/libdeal_II_1d.g$(lib-suffix)
1d : $(LIBDIR)/libdeal_II_1d$(lib-suffix)
2dg: $(LIBDIR)/libdeal_II_2d.g$(lib-suffix)
2d : $(LIBDIR)/libdeal_II_2d$(lib-suffix)
3dg: $(LIBDIR)/libdeal_II_3d.g$(lib-suffix)
3d : $(LIBDIR)/libdeal_II_3d$(lib-suffix)

# create lists of file names. compile vectors.cc first because it is
# one of the files that takes the longest
cc-files     = $D/deal.II/source/numerics/vectors.cc \
               $(filter-out $D/deal.II/source/numerics/vectors.cc, $(shell echo $D/deal.II/source/*/*.cc))
h-files      = $(sort $(shell echo include/*/*.h))

inst-in-files= $(shell echo source/*/*.inst.in)
inst-files   = $(inst-in-files:%.in=%)


# replace subdirectories in cc file names by a prefix, preprend a "lib/[g]o"
# and change the suffix
tmp1        = $(shell echo $(cc-files) | $(PERL) -pi -e 's,$D/deal.II/source/,,g; s,/,_,g;')
o-files-1d  = $(addprefix $(LIBDIR)/1d/, $(tmp1:.cc=_1d.$(OBJEXT)) )
go-files-1d = $(addprefix $(LIBDIR)/1d/, $(tmp1:.cc=_1d.g.$(OBJEXT)))
o-files-2d  = $(addprefix $(LIBDIR)/2d/, $(tmp1:.cc=_2d.$(OBJEXT)) )
go-files-2d = $(addprefix $(LIBDIR)/2d/, $(tmp1:.cc=_2d.g.$(OBJEXT)))
o-files-3d  = $(addprefix $(LIBDIR)/3d/, $(tmp1:.cc=_3d.$(OBJEXT)) )
go-files-3d = $(addprefix $(LIBDIR)/3d/, $(tmp1:.cc=_3d.g.$(OBJEXT)))

o-files  = $(o-files-1d)  $(o-files-2d)  $(o-files-3d)
go-files = $(go-files-1d) $(go-files-2d) $(go-files-3d)


# rules how to generate object files from source files. note that
# there are some files which needs exceptional rules; these are
# listed immediately below
$(LIBDIR)/1d/%.g.$(OBJEXT) :
	@echo "=====deal.II====1d====debug======$(MT)== $(<:$D/deal.II/source/%=%)"
	@$(CXX) $(CXXFLAGS.g) -Ddeal_II_dimension=1 -c $< -o $@
$(LIBDIR)/1d/%.$(OBJEXT) :
	@echo "=====deal.II====1d====optimized==$(MT)== $(<:$D/deal.II/source/%=%)"
	@$(CXX) $(CXXFLAGS.o) -Ddeal_II_dimension=1 -c $< -o $@

$(LIBDIR)/2d/%.g.$(OBJEXT) :
	@echo "=====deal.II====2d====debug======$(MT)== $(<:$D/deal.II/source/%=%)"
	@$(CXX) $(CXXFLAGS.g) -Ddeal_II_dimension=2 -c $< -o $@
$(LIBDIR)/2d/%.$(OBJEXT) :
	@echo "=====deal.II====2d====optimized==$(MT)== $(<:$D/deal.II/source/%=%)"
	@$(CXX) $(CXXFLAGS.o) -Ddeal_II_dimension=2 -c $< -o $@

$(LIBDIR)/3d/%.g.$(OBJEXT) :
	@echo "=====deal.II====3d====debug======$(MT)== $(<:$D/deal.II/source/%=%)"
	@$(CXX) $(CXXFLAGS.g) -Ddeal_II_dimension=3 -c $< -o $@
$(LIBDIR)/3d/%.$(OBJEXT) :
	@echo "=====deal.II====3d====optimized==$(MT)== $(<:$D/deal.II/source/%=%)"
	@$(CXX) $(CXXFLAGS.o) -Ddeal_II_dimension=3 -c $< -o $@

source/%.inst : source/%.inst.in $D/common/template-arguments
	@echo "=====deal.II========================= $(@F)"
	@$D/common/scripts/expand_instantiations $D/common/template-arguments < $< > $@



# in general, when linking shared libraries, we will want to link with
# the underlying libs as well. AIX even requires this. on the other
# hand, on DEC OSF with CXX this will fail with duplicate symbols, so
# make sure that it doesn't happen on that system and that compiler
ifneq ($(GXX-VERSION),compaq_cxx)
  deplibs.g = $(lib-lac.g) $(lib-base.g)
  deplibs.o = $(lib-lac.o) $(lib-base.o)

  # if we use HSL, then we need to link against libhsl.so.
  ifeq ($(USE_CONTRIB_HSL),yes)
    deplibs.g += $(lib-contrib-hsl)
    deplibs.o += $(lib-contrib-hsl)
  endif

  # same with PETSC
  ifeq ($(USE_CONTRIB_PETSC),yes)
    deplibs.g += $(lib-contrib-petsc.g)
    deplibs.o += $(lib-contrib-petsc.o)
  endif

  # same with SLEPC
  ifeq ($(USE_CONTRIB_SLEPC),yes)
    deplibs.g += $(lib-contrib-slepc)
    deplibs.o += $(lib-contrib-slepc)
  endif

  # same with MUMPS
  ifeq ($(USE_CONTRIB_MUMPS),yes)
    deplibs.g += $(lib-contrib-mumps)
    deplibs.o += $(lib-contrib-mumps)
  endif

  # and METIS
  ifeq ($(USE_CONTRIB_METIS),yes)
    deplibs.g += $(lib-contrib-metis)
    deplibs.o += $(lib-contrib-metis)
  endif

  # for cygwin and darwin, also llapack and such are necessary
  # we better link all libraries mentioned in $(LIBS)
  ifneq ($(findstring cygwin,$(TARGET))$(findstring darwin,$(TARGET)),)
    deplibs.g += $(LIBS)
    deplibs.o += $(LIBS)
  endif

else
  deplibs.g =
  deplibs.o =
endif



# rules how to make the libraries themselves
$(LIBDIR)/libdeal_II_1d.g$(static-lib-suffix): $(go-files-1d)
	@echo "=====deal.II====1d====debug======$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(go-files-1d)
	@$(RANLIB) $@
$(LIBDIR)/libdeal_II_1d$(static-lib-suffix): $(o-files-1d)
	@echo "=====deal.II====1d====optimized==$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(o-files-1d)
	@$(RANLIB) $@


$(LIBDIR)/libdeal_II_2d.g$(static-lib-suffix): $(go-files-2d)
	@echo "=====deal.II====2d====debug======$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(go-files-2d)
	@$(RANLIB) $@
$(LIBDIR)/libdeal_II_2d$(static-lib-suffix): $(o-files-2d)
	@echo "=====deal.II====2d====optimized==$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(o-files-2d)
	@$(RANLIB) $@


$(LIBDIR)/libdeal_II_3d.g$(static-lib-suffix): $(go-files-3d)
	@echo "=====deal.II====3d====debug======$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(go-files-3d)
	@$(RANLIB) $@
$(LIBDIR)/libdeal_II_3d$(static-lib-suffix): $(o-files-3d)
	@echo "=====deal.II====3d====optimized==$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(o-files-3d)
	@$(RANLIB) $@


$(LIBDIR)/libdeal_II_1d.g$(shared-lib-suffix): $(go-files-1d)
	@echo "=====deal.II====1d====debug======$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II_1d.g) $(call DEAL_II_ADD_SONAME,deal_II_1d.g) $(go-files-1d) $(deplibs.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II_1d.g) $@

$(LIBDIR)/libdeal_II_1d$(shared-lib-suffix): $(o-files-1d)
	@echo "=====deal.II====1d====optimized==$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II_1d) $(call DEAL_II_ADD_SONAME,deal_II_1d) $(o-files-1d) $(deplibs.o)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II_1d) $@


$(LIBDIR)/libdeal_II_2d.g$(shared-lib-suffix): $(go-files-2d)
	@echo "=====deal.II====2d====debug======$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II_2d.g) $(call DEAL_II_ADD_SONAME,deal_II_2d.g) $(go-files-2d) $(deplibs.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II_2d.g) $@

$(LIBDIR)/libdeal_II_2d$(shared-lib-suffix): $(o-files-2d)
	@echo "=====deal.II====2d====optimized==$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II_2d) $(call DEAL_II_ADD_SONAME,deal_II_2d) $(o-files-2d) $(deplibs.o)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II_2d) $@


$(LIBDIR)/libdeal_II_3d.g$(shared-lib-suffix): $(go-files-3d)
	@echo "=====deal.II====3d====debug======$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II_3d.g) $(call DEAL_II_ADD_SONAME,deal_II_3d.g) $(go-files-3d) $(deplibs.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II_3d.g) $@

$(LIBDIR)/libdeal_II_3d$(shared-lib-suffix): $(o-files-3d)
	@echo "=====deal.II====3d====optimized==$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,deal_II_3d) $(call DEAL_II_ADD_SONAME,deal_II_3d) $(o-files-3d) $(deplibs.o)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,deal_II_3d) $@



# Rule to generate the dependency file. This file is
# automagically remade whenever needed, i.e. whenever
# one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom
# of this file.
#
# If the command fails, then remove Makefile.dep again and fail
Makefile.dep: $(cc-files) $(h-files) \
		$(inst-files) \
		Makefile $D/common/Make.global_options
	@echo "===================================== Remaking deal.II/Makefile"
	@(for dir in dofs fe grid hp multigrid numerics ; do \
		$D/common/scripts/make_dependencies $(INCLUDE) "-B\$$(LIBDIR)" `echo $D/deal.II/source/$$dir/*cc` \
		| $(PERL) -p -e 's!LIBDIR\)/(.*):!LIBDIR)/DIM_PLACEHOLDER/$$1:!g;' \
		| $(PERL) -pe 's!((\.g)?.$(OBJEXT)):!_DIM_PLACEHOLDER$$1:!g;' \
	        | $(PERL) -pe 's!^(.*)/DIM_PLACEHOLDER/(.*)_DIM_PLACEHOLDER(\..*):!$$1/1d/DIRPLACEHOLDER_$$2_1d$$3 $$1/2d/DIRPLACEHOLDER_$$2_2d$$3 $$1/3d/DIRPLACEHOLDER_$$2_3d$$3:!g;'\
		| $(PERL) -pe "s/DIRPLACEHOLDER/$$dir/g;" \
		; done ) > $@ \
	 || (rm -f $@ ; false)


# include all the dependencies
include Makefile.dep




################### some clean-up rules

clean:
	-rm -f *~ */*~ */*/*~ Makefile.dep source/*/*.inst


###################

.PHONY: all deal.II TAGS
.PHONY: clean
.PHONY: default 1d 2d 3d all

=== examples/Makefile ===
# $Id: Makefile 11114 2005-07-08 14:41:09Z guido $
#
# This Makefile only recurses into the subdirs
include ../common/Make.global_options

all: default

# existing examples. take dirnames and strip 'step'
steps = $(shell echo step-? step-??)


# default is: build all examples. for each example, there is a target
# build-step-N, where N in [1...]
default: $(addprefix build-,$(steps)) doxygen

# run example programs; make a target run-step-N for each N
run: $(addprefix run-,$(steps)) run-doxygen

# clean subdirs; make a target clean-step-N for each N
clean:
	-rm -f *~ */*~ */*.$(OBJEXT) */*gmv */*gnuplot */*gpl */*eps */*pov */*tex \
	$(addsuffix $(EXEEXT),$(basename $(shell echo step-*/step-*.cc))) \
	doxygen/*.o doxygen/*.exe */Makefile.dep


# for each build/run/clean target: strip the build- prefix of the
# target and build in that directory
build-step-%:
	cd $(@:build-%=%) ; $(MAKE)
run-step-%:
	cd $(@:run-%=%) ; $(MAKE) run
clean-step-%:
	cd $(@:clean-%=%) ; $(MAKE) clean
doxygen:
	cd doxygen ; $(MAKE)
run-doxygen:
	cd doxygen ; $(MAKE) run
clean-doxygen:
	cd doxygen ; $(MAKE) clean

# all targets in this directory do not produce files, so they are
# .PHONY:
.PHONY: $(addprefix build-step-,$(steps)) \
        $(addprefix run-step-,$(steps))   \
        $(addprefix clean-step-,$(steps)) \
	doxygen doxygen-run doxygen-clean

=== lac/Makefile ===
# $Id: Makefile 21470 2010-07-11 23:20:30Z bangerth $
# Copyright W. Bangerth, University of Heidelberg, 1998, 1999, 2000, 2001, 2002


# deal.II top level directory
D=..

# get options which hold for all files of the project
include $D/common/Make.global_options


# create lists of file names
cc-files     = $(shell echo $D/lac/source/*.cc)
o-files-base = $(sort $(addprefix $(LIBDIR)/lac/, $(patsubst $D/lac/source/%,%,$(cc-files:.cc=.$(OBJEXT)))))
o-files      = $(o-files-base)
go-files     = $(o-files-base:.$(OBJEXT)=.g.$(OBJEXT))
h-files      = $(sort $(shell echo include/lac/*.h))

inst-in-files= $(shell echo source/*.inst.in)
inst-files   = $(inst-in-files:%.in=%)

# if umfpack was configured, simply link all the umfpack files into liblac.
# these object files should have been generated before we got to the present
# directory
ifeq ($(USE_CONTRIB_UMFPACK),yes)
  umfpack-files = $(sort $(shell echo $(LIBDIR)/contrib/umfpack/*.$(OBJEXT)))
  o-files += $(umfpack-files)
  go-files += $(umfpack-files)
endif


# production rules
$(LIBDIR)/lac/%.g.$(OBJEXT) :
	@echo "=====lac==============debug======$(MT)== $(<F)"
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@
$(LIBDIR)/lac/%.$(OBJEXT) :
	@echo "=====lac==============optimized==$(MT)== $(<F)"
	@$(CXX) $(CXXFLAGS.o) -c $< -o $@

source/%.inst : source/%.inst.in $D/common/template-arguments
	@echo "=====lac============================= $(@F)"
	@$D/common/scripts/expand_instantiations $D/common/template-arguments < $< > $@

# rules
lib: $(LIBDIR)/liblac.g$(lib-suffix) $(LIBDIR)/liblac$(lib-suffix)
libg: $(LIBDIR)/liblac.g$(lib-suffix)
libo: $(LIBDIR)/liblac$(lib-suffix)

# in general, when linking shared libraries, we will want to link with
# the underlying libs as well. AIX even requires this. on the other
# hand, on DEC OSF with CXX this will fail with duplicate symbols, so
# make sure that it doesn't happen on that system and that compiler
ifneq ($(GXX-VERSION),compaq_cxx)
  deplibs.g = $(lib-base.g)
  deplibs.o = $(lib-base.o)

  # if we use HSL, then we need to link against libhsl.so.
  ifeq ($(USE_CONTRIB_HSL),yes)
    deplibs.g += $(lib-contrib-hsl)
    deplibs.o += $(lib-contrib-hsl)
  endif

  # same with PETSC
  ifeq ($(USE_CONTRIB_PETSC),yes)
    deplibs.g += $(lib-contrib-petsc.g)
    deplibs.o += $(lib-contrib-petsc.o)
  endif

  # same with SLEPC
  ifeq ($(USE_CONTRIB_SLEPC),yes)
    deplibs.g += $(lib-contrib-slepc)
    deplibs.o += $(lib-contrib-slepc)
  endif

  # same with TRILINOS
  ifeq ($(USE_CONTRIB_TRILINOS),yes)
    deplibs.g += $(lib-contrib-trilinos)
    deplibs.o += $(lib-contrib-trilinos)
  endif

  # same with MUMPS
  ifeq ($(USE_CONTRIB_MUMPS),yes)
    deplibs.g += $(lib-contrib-mumps)
    deplibs.o += $(lib-contrib-mumps)
  endif

  # and METIS
  ifeq ($(USE_CONTRIB_METIS),yes)
    deplibs.g += $(lib-contrib-metis)
    deplibs.o += $(lib-contrib-metis)
  endif

  # for cygwin and darwin, also llapack and such are necessary
  # we better link all libraries mentioned in $(LIBS)
  ifneq ($(findstring cygwin,$(TARGET))$(findstring darwin,$(TARGET)),)
    deplibs.g += $(LIBS)
    deplibs.o += $(LIBS)
  endif

else
  deplibs.g =
  deplibs.o =
endif


$(LIBDIR)/liblac$(static-lib-suffix): $(o-files)
	@echo "=====lac==============optimized==$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(o-files)
	@$(RANLIB) $@

$(LIBDIR)/liblac.g$(static-lib-suffix): $(go-files)
	@echo "=====lac==============debug======$(MT)== Linking library:   $(@F)"
	@$(AR) ru $@ $(go-files)
	@$(RANLIB) $@


$(LIBDIR)/liblac$(shared-lib-suffix): $(o-files)
	@echo "=====lac==============optimized==$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,lac) $(call DEAL_II_ADD_SONAME,lac) $(o-files) $(deplibs.o)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,lac) $@

$(LIBDIR)/liblac.g$(shared-lib-suffix): $(go-files)
	@echo "=====lac==============debug======$(MT)== Linking library:   $(@F)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,lac.g) $(call DEAL_II_ADD_SONAME,lac.g) $(go-files) $(deplibs.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,lac.g) $@


# generate a file that contains prototypes for BLAS and LAPACK functions
include/lac/lapack_templates.h: include/lac/lapack_templates.h.in $D/common/scripts/lapack_templates.pl
	@echo ===================================== Remaking $@
	@$(PERL) $D/common/scripts/lapack_templates.pl include/lac/lapack_templates.h.in > $@


clean:
	-rm -f *~ include/*~ include/*/*~ Makefile.dep source/*.inst


# Rule to generate the dependency file. This file is
# automagically remade whenever needed, i.e. whenever
# one of the cc-/h-files changed. Make detects whether
# to remake this file upon inclusion at the bottom
# of this file.
#
# If the command fails, then remove Makefile.dep again and fail
Makefile.dep: include/lac/lapack_templates.h \
	      $(cc-files) $(h-files) $(inst-files) \
		Makefile $D/common/Make.global_options
	@echo ===================================== Remaking lac/Makefile
	@$D/common/scripts/make_dependencies $(INCLUDE) "-B$(LIBDIR)/lac" $(cc-files) \
		> $@ \
	 || (rm -f $@ ; false)


# include all the dependencies
include Makefile.dep

.PHONY: clean
.PHONY: lib lib$(static-lib-suffix) lib.g$(static-lib-suffix)

=== lib/Makefile ===
# $Id: Makefile 20925 2010-03-30 09:14:58Z young $
# Copyright W. Bangerth, University of Heidelberg, 2002

D = ..

# get options which hold for all files of the project
include $D/common/Make.global_options


default:
	@echo There is no default target in this directory


######################### EXTERNAL LINK TARGETS ###################
# link in external libs, if any
external-links: external-links-petsc

ifeq ($(USE_CONTRIB_PETSC),yes)

  # PETSc has the nasty habit of putting debug and optimized builds into
  # different directories, but naming the respective libraries the same.
  # Since one doesn't want to always set and reset $LD_LIBRARY_PATH when
  # one switches from debug to optimized mode, they pass -Wl,-rpath to
  # the linker line. This is not really portable, and it has the additional
  # drawback that one has to pass different linker flags for debug and
  # optimized mode. The latter is a problem with our present build system,
  # which allows to use different libraries, but doesn't take into account
  # that one may want to pass different $LDFLAGS.
  #
  # To avoid such hassle, we build some kind of convenience library: a shared
  # library that has no content, but contains references to all the different
  # PETSc libraries, and we build one for debug and one for optimized mode.
  # We can't really get around the use of -Wl,-rpath, but at least we
  # have now centralized this part to one single place, and are back to where
  # we want to be: have different libraries for debug and optimized mode,
  # but in the same directory. And, voila, our build system works again :-)
  #
  # There is one gotcha: PETSc has a habit of making incompatible changes by
  # simply changing the names of libraries between different versions. That
  # really is too bad, so we have to conditionalize things.
ifeq ($(DEAL_II_PETSC_VERSION_MINOR),1)
  xlib-ksp=libpetscsles
else
  xlib-ksp=libpetscksp
endif
  # This is how it is done. Starting with PETSc versions 2.3.*:
ifeq ($(DEAL_II_PETSC_VERSION_MAJOR),2)
  xlib.g = $(lib-contrib-petsc-path.g)/libpetscksp$(lib-suffix) \
           $(lib-contrib-petsc-path.g)/libpetscdm$(lib-suffix)  \
           $(lib-contrib-petsc-path.g)/libpetscmat$(lib-suffix) \
           $(lib-contrib-petsc-path.g)/libpetscvec$(lib-suffix) \
           $(lib-contrib-petsc-path.g)/libpetsc$(lib-suffix)
  xlib.o = $(lib-contrib-petsc-path.o)/libpetscksp$(lib-suffix) \
           $(lib-contrib-petsc-path.o)/libpetscdm$(lib-suffix)  \
           $(lib-contrib-petsc-path.o)/libpetscmat$(lib-suffix) \
           $(lib-contrib-petsc-path.o)/libpetscvec$(lib-suffix) \
           $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
else
  # which is the same for PETSc 3.0.0:
  ifeq ($(DEAL_II_PETSC_VERSION_MAJOR)$(DEAL_II_PETSC_VERSION_MINOR),30) 
    xlib.g = $(lib-contrib-petsc-path.g)/libpetscksp$(lib-suffix) \
             $(lib-contrib-petsc-path.g)/libpetscdm$(lib-suffix)  \
             $(lib-contrib-petsc-path.g)/libpetscmat$(lib-suffix) \
             $(lib-contrib-petsc-path.g)/libpetscvec$(lib-suffix) \
             $(lib-contrib-petsc-path.g)/libpetsc$(lib-suffix)
    xlib.o = $(lib-contrib-petsc-path.o)/libpetscksp$(lib-suffix) \
             $(lib-contrib-petsc-path.o)/libpetscdm$(lib-suffix)  \
             $(lib-contrib-petsc-path.o)/libpetscmat$(lib-suffix) \
             $(lib-contrib-petsc-path.o)/libpetscvec$(lib-suffix) \
             $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
  else 
    # but after that (petsc-3.1++), we can use the simpler PETSc
    # default "--with-single-library=1" like this:
    xlib.g = $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
    xlib.o = $(lib-contrib-petsc-path.o)/libpetsc$(lib-suffix)
  endif
endif

ifeq ($(enable-shared),yes)

  external-links-petsc: libpetscall.g$(shared-lib-suffix) libpetscall$(shared-lib-suffix)

  libpetscall.g$(shared-lib-suffix): $(xlib.g)
	@echo "======================debug============= Linking library:   libpetscall.g$(shared-lib-suffix)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,petscall.g) $(call DEAL_II_ADD_SONAME,petscall.g) $(xlib.g)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,petscall.g) $@

  libpetscall$(shared-lib-suffix): $(xlib.o)
	@echo "======================optimized========= Linking library:   libpetscall$(shared-lib-suffix)"
	@$(SHLIBLD) $(LDFLAGS) $(SHLIBFLAGS) -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,petscall) $(call DEAL_II_ADD_SONAME,petscall)  $(xlib.o)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,petscall) $@

else

  # make static libraries. ensure that they are built one after the other because
  # both create temporary files with the same name
  external-links-petsc: 
	@$(MAKE) libpetscall.g$(static-lib-suffix)
	@$(MAKE) libpetscall$(static-lib-suffix)

  # As I don't know how to merge archives, here's a workaround: Extract each of
  # the archives and append the object files to the libpetsc archive. Do the
  # same for debug and optimized mode.
  libpetscall.g$(static-lib-suffix): $(xlib.g)
	@echo "======================debug============= Linking library:   libpetscall.g$(static-lib-suffix)"
	@rm -f $@
	@rm -rf .ar_tmp
	@mkdir .ar_tmp; cd .ar_tmp; \
	 for arfile in $(xlib.g) ; do \
	   $(AR) x $$arfile; \
           $(AR) q ../libpetscall.g$(static-lib-suffix) *; \
           rm *; \
	 done
	@cd ..
	@rm -r .ar_tmp
	@$(RANLIB) libpetscall.g$(static-lib-suffix)

  libpetscall$(static-lib-suffix): $(xlib.o)
	@echo "======================optimized========= Linking library:   libpetscall$(static-lib-suffix)"
	@rm -f $@
	@rm -rf .ar_tmp
	@mkdir .ar_tmp; cd .ar_tmp; \
	 for arfile in $(xlib.o) ; do \
	   $(AR) x $$arfile; \
           $(AR) q ../libpetscall$(static-lib-suffix) *; \
           rm *; \
	 done
	@cd ..
	@rm -r .ar_tmp
	@$(RANLIB) libpetscall$(static-lib-suffix)
endif


else
  external-links-petsc:
endif



######################### CLEAN TARGETS ###################
# clean everything
clean: clean-objects clean-bin

# only clean object files, not libraries and executables
clean-objects:  clean-base clean-lac \
		clean-1d clean-2d clean-3d \
		clean-contrib


# clean targets for the individual subdirectories. remove
# object files and template instantiation files.
# extract dir name from target
clean-base clean-lac clean-1d clean-2d clean-3d:
	-cd $(@:clean-%=%) ; rm *.$(OBJEXT) *.ti *.ii

clean-contrib:
	-rm contrib/*/*.$(OBJEXT)
	-rm -r contrib/tbb/*debug
	-rm -r contrib/tbb/*release
	-rm libtbb*

clean-bin:
	-rm bin/detached_ma27

distclean: clean
	-rm -f lib* bin/*

.PHONY: clean clean-objects 
.PHONY: clean-base clean-lac clean-1d clean-2d clean-3d
.PHONY: clean-contrib
.PHONY: external-links external-links-petsc

=== common/scripts/Makefile ===
# $Id: Makefile 20713 2010-02-28 20:54:52Z bangerth $
# Copyright W. Bangerth, 2003


# deal.II top level directory
D=../..

include $D/common/Make.global_options

default: make_dependencies expand_instantiations


# rules to generate the program. let is be dependent on the global flags for
# the following reason: if you go to a different system, but keep with the
# same directory, you get into trouble because make_dependencies is not
# deleted by "make clean"; following this, we generate empty Makefile.dep's
# because we can't run the executable. So better be careful and regenerate
# make_dependencies whenever we think it may be beneficial
make_dependencies : make_dependencies.cc $D/common/Make.global_options
	@echo ============================ Compiling $@
	@$(CXX) $(CXXFLAGS.o) $(LDFLAGS) $< -o $@

expand_instantiations : expand_instantiations.cc $D/common/Make.global_options
	@echo ============================ Compiling $@
	@$(CXX) $(CXXFLAGS.o) $(LDFLAGS) $< -o $@

clean:
	-rm -f make_dependencies
	-rm -f make_dependencies.o
	-rm -f expand_instantiations
	-rm -f expand_instantiations.o

.PHONY: clean

=== contrib/functionparser/Makefile ===
# $Id: Makefile 18849 2009-05-15 17:59:46Z bangerth $
# Copyright (C) 2005, 2008 by Wolfgang Bangerth


D = ../..

include $D/common/Make.global_options

# rules
$(LIBDIR)/contrib/functionparser/fparser.$(OBJEXT): fparser.cc fparser.h
	@echo =====function parser==optimized==$(MT)== $(<F)
	@$(CXX) $(CXXFLAGS.o) -c fparser.cc -o $@



clean:
	-rm -f *~ 


.PHONY: clean

=== contrib/hsl/Makefile ===
# $Id: Makefile 19427 2009-09-10 02:34:12Z bangerth $
# Copyright (C) 2001, 2002, 2003, 2004, 2006, 2008, 2009 by Wolfgang Bangerth


D = ../..

include $D/common/Make.global_options

# get lists of files we need
f-files     = $(shell a="`echo source/*.f`"; if test "$$a" != "source/*.f" ; then echo $$a ; fi)
o-files     = $(f-files:source/%.f=$(LIBDIR)/contrib/hsl/%.$(OBJEXT))




# rules
lib: $(LIBDIR)/libhsl$(lib-suffix) $(LIBDIR)/bin/detached_ma27$(EXEEXT)



$(LIBDIR)/contrib/hsl/%.$(OBJEXT) :
	@echo =====hsl==============optimized==$(MT)== $(<F)
	@$(F77) $(F77FLAGS.o) -c $< -o $@


$(LIBDIR)/contrib/hsl/detached_ma27.$(OBJEXT) : source/detached_ma27.cc \
						include/hsl/hsl.h
	@echo =====hsl==============optimized==$(MT)== $(<F)
	@$(CXX) $(CXXFLAGS.g) -c $< -o $@


$(LIBDIR)/libhsl$(static-lib-suffix): $(forward-declarations) $(o-files)
	@echo =====hsl==============optimized==$(MT)== Linking library:   $(@F)
	@$(AR) ru $@ $(o-files)
	@$(RANLIB) $@

# link the object files to a shared library.
$(LIBDIR)/libhsl$(shared-lib-suffix): $(forward-declarations) $(o-files)
	@echo =====hsl==============optimized==$(MT)== Linking library:   $(@F)
	@$(SHLIBLD) $(LDFLAGS) -shared -o $(LIBDIR)/$(call DEAL_II_SHLIB_NAME,hsl) $(call DEAL_II_ADD_SONAME,hsl) $(o-files) $(F77LIBS)
	@ln -f -s $(call DEAL_II_SHLIB_NAME,hsl) $@



# rule to make the program that runs an MA27 solver detached from the
# main program, and communicates through a pipe. since this program
# has actually nothing much to do, compile it in debug mode
$(LIBDIR)/bin/detached_ma27$(EXEEXT):  \
				$(LIBDIR)/contrib/hsl/detached_ma27.$(OBJEXT) \
				$(LIBDIR)/libhsl$(lib-suffix)
	@echo =====hsl=========================$(MT)== Making   $(@F)
	@$(CXX) $(CXXFLAGS.g) $^ -o $@ $(F77LIBS) -lpthread $(LIBS)



clean:
	-rm -f *~ lib/lib* lib/o/*.$(OBJEXT) lib/Makefile.dep



# Rule to generate the dependency file. This file is
# automagically remade whenever needed, i.e. whenever
# one of the f-files changed. Make detects whether
# to remake this file upon inclusion at the bottom
# of this file.
#
# note that we take care if there are no f-files
#
# If the command fails, then remove Makefile.dep again and fail
Makefile.dep: $(f-files) Makefile
	@echo ============================ Remaking Makefile
	@(if test "x$(f-files)" != "x" ; then \
           for i in source/*.f ; do \
	     echo $$i | $(PERL) -pi -e 's#source/(.*)\.f#\$$(LIBDIR)/contrib/hsl/\1.$(OBJEXT):source/\1.f#;' ;\
	    done ; \
          fi) \
		> $@ \
	 || (rm -f $@ ; false)


# include all the dependencies
include Makefile.dep


.PHONY: clean
.PHONY: lib lib$(static-lib-suffix) lib.g$(static-lib-suffix)

=== contrib/mesh_conversion/Makefile ===
SHELL = /bin/sh

#MACROS
CPP = g++ -g -ansi -pedantic -Wall
PROG = convert_mesh

#SUFFIX RULES
.SUFFIXES: .o .cc
.cc.o:
	$(CPP) -c $<

all: $(PROG)

$(PROG): Main.o MeshConversion.o
	$(CPP)	-o	$(PROG)	Main.o MeshConversion.o
Main.o:	Main.cc 	MeshConversion.o
MeshConversion.o:	MeshConversion.cc

clean:
	@echo "-------------------------------------------------"
	@echo "REMOVING EXECUTABLES, *.o, a.out AND FILE BACKUPS"
	-rm -f  ${PROG} *.o *.*~ makefile~ *~
	@echo "-------------------------------------------------"

clean-temp:
	@echo "-------------------------------------------------"
	@echo "REMOVING EXECUTABLES, *.o, a.out AND FILE BACKUPS"
	-rm -f  *.o *.*~ makefile~ *~
	@echo "-------------------------------------------------"

=== contrib/tbb/Makefile ===
# bild the tbb libraries. they end up in directories with weird names that contain
# the system and compiler names etc. rename them to something that's a bit more
# predictable for the downstream make files.
tbb:
	@cd tbb22_20090809oss ; $(MAKE) tbb tbb_build_dir=$D/lib/contrib/tbb
	@rm -f $D/lib/libtbb*
	@for i in $D/lib/contrib/tbb/*_debug/libtbb_debug* ; do \
	    ln -s -f $$i $D/lib/`echo $$i | $(PERL) -pi -e 's#.*/##g;'` ; done
	@for i in $D/lib/contrib/tbb/*_release/libtbb* ; do \
	    ln -s -f $$i $D/lib/`echo $$i | $(PERL) -pi -e 's#.*/##g;'` ; done


# nothing to do here: tbb builds everything in $D/lib/contrib/tbb
clean:

.PHONY: tbb clean

include ../../common/Make.global_options

=== contrib/umfpack/Makefile ===
include ../../common/Make.global_options

deplibs = 

# for cygwin, lapack and other libraries are necessary to link with
ifeq ($(findstring cygwin,$(TARGET)),cygwin)
  deplibs = $(LIBS)
endif


# rules
lib: AMD UMFPACK


AMD:
	cd AMD/Source ; $(MAKE) all

UMFPACK:
	cd UMFPACK/Source ; $(MAKE) all

clean:


.PHONY: AMD UMFPACK clean lib

=== debian/changelog ===
deal.ii (6.3.1-1ubuntu1) natty; urgency=low

  * debian/control: updated dependencies for libslepc3.1 transition
  * slepc-3.1.patch: taken from upstream to adapt to slepc3.1 API change

 -- Fabrice Coutadeur <fabricesp@ubuntu.com>  Mon, 14 Mar 2011 20:44:55 +0000

deal.ii (6.3.1-1) unstable; urgency=low

  [ Adam C. Powell, IV ]
  * Changed to source format 3.0 (quilt).
  * Changed maintainer to debian-science with Adam Powell as uploader.
  * Added source lintian overrides about Adam Powell's name.
  * Added Vcs info on git repository.
  * Bumped Standards-Version.
  * Changed stamp-patch to patch target and fixed its application criterion.
  * Moved make_dependencies and expand_instantiations to a versioned directory
    to avoid shlib package conflicts.

  [ Denis Barbier ]
  * New upstream release (closes: #562332).
    + Added libtbb support.
    + Forward-ported all patches.
  * Updates for new PETSc version, including workaround for different versions
    of petsc and slepc.
  * Add debian/watch.
  * Update to debhelper 7.
  * Added pdebuild patch.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Thu, 29 Jul 2010 13:47:01 -0400

deal.ii (6.2.1-2) unstable; urgency=low

  * Added libboost-python-dev to Build-Depends (closes: #549716).
  * Bumped Standards-Version.
  * Added README.source.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 03 Nov 2009 08:07:34 -0500

deal.ii (6.2.1-1) unstable; urgency=low

  * New upstream release.
  * Removed backslashes from dependencies (closes: #535284).
  * Added libboost-graph-dev to Build-Depends (closes: #533629).
  * Updated Standards-Version.
  * Updated debhelper Build-Depends version.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 21 Jul 2009 08:02:26 -0400

deal.ii (6.2.0-3) unstable; urgency=low

  * Added libslepc3.0.0-dev to Build-Depends (closes: #529162).
  * Completed Trilinos linkage, which requires a version of Trilinos including
    a working Sacado package.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Thu, 21 May 2009 07:41:33 -0400

deal.ii (6.2.0-2) unstable; urgency=low

  * Added Trilinos linkage.
  * Changed compilers to mpicc and mpicxx to make trilinos tests work.
  * Fixed library variables using a sed hack.
  * Added PIC flag to soname test.
  * Fixed a couple of other lintian warnings.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Fri, 08 May 2009 23:13:50 -0400

deal.ii (6.2.0-1) unstable; urgency=low

  * New upstream which builds with PETSc 3.0.
  * Disabled build of contrib/functionparser.
  * Minor update to metis patch.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Fri, 08 May 2009 10:44:16 -0400

deal.ii (6.1.0-5) unstable; urgency=low

  * Removed the section of the copyright file regarding contrib/dx/* because
    that directory is under the same copyright and license as the rest of the
    code (Files: *).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Tue, 30 Dec 2008 02:42:29 -0500

deal.ii (6.1.0-4) unstable; urgency=low

  * Added --with-boost to configure to use Debian boost during compilation
    instead of contrib/boost.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Mon, 17 Nov 2008 21:47:37 -0500

deal.ii (6.1.0-3) unstable; urgency=low

  * Found and added additional copyright holders to debian/copyright.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Thu, 06 Nov 2008 23:02:27 -0500

deal.ii (6.1.0-2) unstable; urgency=low

  * Patched doxygen docs to eliminate equation latex errors.
  * Made build-doc rule depend on stamp-configure.
  * -dev package now depends on many -dev packages, including boost.
  * Removed compression from -examples package .cc and .inp files.
  * Cleaned up Make.global_options and example Makefiles so they work.
  * Included instructions for running examples in README.Debian.html.

 -- Adam C. Powell, IV <hazelsct@debian.org>  Wed, 17 Sep 2008 11:01:46 -0400

deal.ii (6.1.0-1) unstable; urgency=low

  * First package (closes: #494729).

 -- Adam C. Powell, IV <hazelsct@debian.org>  Thu, 28 Aug 2008 14:46:46 -0400

=== debian/control ===
Source: deal.ii
Section: devel
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: "Adam C. Powell, IV" <hazelsct@debian.org>
Standards-Version: 3.9.1
Build-Depends: debhelper (>= 7), quilt, automake, autoconf, gfortran, zlib1g-dev,
  libblas-dev, liblapack-dev, libpetsc3.1-dev, libslepc3.1-dev,
  libtrilinos-dev (>=9.0.2.dfsg-4), libscotchmetis-dev (>= 5.1.4.dfsg-2),
  libsuitesparse-dev, libnetcdf-dev, libboost-dev, libboost-graph-dev,
  libboost-python-dev, libtbb-dev, libtbb2-dbg
Build-Depends-Indep: doxygen, graphviz, texlive-latex-base, ghostscript
Vcs-Git: git://git.debian.org/git/debian-science/packages/deal.ii.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/deal.ii.git
Homepage: http://www.dealii.org/

Package: libdeal.ii-dbg6.3.1
Architecture: any
Section: debug
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Finite element library - shared library
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the debugging shared libraries.

Package: libdeal.ii-dbg
Architecture: all
Section: debug
Depends: libdeal.ii-dbg6.3.1 (>= ${source:Version}), ${misc:Depends}
Recommends: libdeal.ii-dev (= ${source:Version}), libtbb2-dbg
Description: Finite element library - development files
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains development files for using debugging shared libraries.

Package: libdeal.ii6.3.1
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Finite element library - shared library
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the optimized shared libraries.

Package: libdeal.ii-dev
Architecture: all
Section: libdevel
Depends: libdeal.ii6.3.1 (>= ${source:Upstream-Version}), libblas-dev, liblapack-dev, libpetsc3.1-dev, libslepc3.1-dev, libtrilinos-dev (>=9.0.2.dfsg-3), libscotchmetis-dev (>= 5.1.4.dfsg-2), libsuitesparse-dev, libnetcdf-dev, libboost-dev, libtbb-dev, ${misc:Depends}
Suggests: libdeal.ii-dbg, deal.ii-doc, deal.ii-examples
Description: Finite element library - development files
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains development files for using optimized shared libraries.

Package: deal.ii-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Finite element library - documentation
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the documentation.

Package: deal.ii-examples
Architecture: all
Section: doc
Depends: ${misc:Depends}
Recommends: libdeal.ii-dev
Description: Finite element library - documentation
 deal.II is a C++ program library targeted at the computational
 solution of partial differential equations using adaptive finite elements.
 It uses state-of-the-art programming techniques to offer you a modern
 interface to the complex data structures and algorithms required.  The main
 aim of deal.II is to enable rapid development of modern finite element codes,
 using among other aspects adaptive meshes and a wide array of tools classes
 often used in a finite element program.
 .
 This package contains the tutorial examples' source code.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of debmake, by Christoph Lameter,
# based on the sample debian/rules file for GNU hello by Ian Jackson.

package=deal.ii
version=6.3.1

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
         MAKEFLAGS += -j$(NUMJOBS)
endif

patch:
	if [ ! -d .pc ]; then \
	  QUILT_PATCHES=debian/patches quilt push -a || test $$? = 2; \
	fi

clean:
	dh_testdir
	if [ -e common/Make.global_options ]; then $(MAKE) distclean; fi
	if [ -d .pc ]; then \
	  QUILT_PATCHES=debian/patches quilt pop -a -R || test $$? = 2; \
	  rm -rf .pc; \
	fi
	rm -f stamp-* build-doc install
	rm -f config.status config.log
	rm -f contrib/config.status contrib/config.log
	rm -f contrib/utilities/config.status contrib/utilities/config.log

	rm -f common/Make.global_options common/Makefile.template common/Make.global_options 
	rm -f common/template-arguments common/scripts/make_dependencies.pl
	rm -f Version configure contrib/Makefile contrib/configure contrib/utilities/Makefile contrib/utilities/configure
	rm -f base/include/base/config.h base/include/base/config.h.in
	rm -f lac/include/lac/lapack_templates.h
	rm -f doc/doxygen/header.html doc/doxygen/header.tex
	rm -f doc/doxygen/header.136 doc/doxygen/options.136
	rm -f doc/doxygen/tutorial/toc.html
	rm -f doc/doxygen/Makefile
	rm -f doc/development/makefile.rules.html

	rm -f doc/Makefile doc/doxygen/doxygen.log doc/doxygen/*.dox
	dh_clean

stamp-configure: patch
	dh_testdir
	aclocal --force
	autoreconf -i -v
	CXX=mpicxx CC=mpicc PETSC_DIR=/usr/lib/petsc PETSC_ARCH=`petscarch` \
	  SLEPC_DIR=/usr/lib/slepc SLEPC_ARCH=linux-gnu-c-opt \
	  ./configure --prefix=/usr --enable-parser --enable-multithreading \
	  --enable-shared \
	  --with-boost-libs=/usr/lib --with-boost-include=/usr/include/boost \
	  --with-blas --with-lapack \
	  --with-umfpack-libs=/usr/lib --with-umfpack-include=/usr/include/suitesparse \
	  --with-metis-libs=/usr/lib --with-metis-include=/usr/include/metis/ \
	  --with-trilinos-libs=/usr/lib --with-trilinos-include=/usr/include/trilinos \
	  --with-netcdf-libs=/usr/lib --with-netcdf-include=/usr/include
	touch $@

build: stamp-build
stamp-build: stamp-configure
	dh_testdir
# Move aside Make.global_options and replace it with something temporary
	mv common/Make.global_options common/Make.global_options.orig
	sed 's/$$(LIBDIR)\/lib/-L$$(LIBDIR) -l/' < common/Make.global_options.orig \
	  | sed 's/.g$$(lib-suffix)/.g/' | sed 's/call$$(lib-suffix)/call/' \
	  | sed 's/hsl$$(lib-suffix)/hsl/' | sed 's/ase$$(lib-suffix)/ase/' \
	  | sed 's/lac$$(lib-suffix)/lac/' | sed 's/_1d$$(lib-suffix)/_1d/' \
	  | sed 's/_2d$$(lib-suffix)/_2d/' | sed 's/_3d$$(lib-suffix)/_3d/' \
	  > common/Make.global_options
	$(MAKE) $(MAKEFLAG) all
	touch $@

build-doc: stamp-configure
	$(MAKE) $(MAKEFLAG) online-doc
	touch $@

install: build
# We distribute the libs, and put the includes and common files in -dev
	install -d debian/libdeal.ii-dbg$(version)/usr/lib
	mv lib/*.g.so.$(version) debian/libdeal.ii-dbg$(version)/usr/lib/
	install -d debian/libdeal.ii$(version)/usr/lib
	mv lib/*.so.$(version) debian/libdeal.ii$(version)/usr/lib/
	install -d debian/libdeal.ii-dbg/usr/lib
	mv lib/*.g.so debian/libdeal.ii-dbg/usr/lib/
	install -d debian/libdeal.ii-dev/usr/lib
	mv lib/*.so debian/libdeal.ii-dev/usr/lib/
	install -d debian/libdeal.ii-dev/usr/include/deal.II
	cp -a deal.II/include/* lac/include/* base/include/* \
	  debian/libdeal.ii-dev/usr/include/deal.II/
	install -d debian/libdeal.ii-dev/usr/share/deal.II
	cp -a common/* debian/libdeal.ii-dev/usr/share/deal.II
# Fix Make.global_options
	rm -f debian/libdeal.ii-dev/usr/share/deal.II/Make.global_options*
	sed "s/`echo $(CURDIR) | sed 's/\//\\\\\//g'`/\/usr/" \
	  < common/Make.global_options.orig | \
	  sed 's/deal.II\/include/include\/deal.II/' \
	  > debian/libdeal.ii-dev/usr/share/deal.II/Make.global_options
# There are a couple of binaries in common/scripts which belong in $(version)
	install -d debian/libdeal.ii$(version)/usr/lib/deal.II-$(version)
	mv debian/libdeal.ii-dev/usr/share/deal.II/scripts/expand_instantiations \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_dependencies \
	  debian/libdeal.ii$(version)/usr/lib/deal.II-$(version)/
	ln -s ../../../lib/deal.II-$(version)/expand_instantiations \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/expand_instantiations
	ln -s ../../../lib/deal.II-$(version)/make_dependencies \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_dependencies
	rm -f debian/libdeal.ii-dev/usr/share/deal.II/scripts/*.cc \
	  debian/libdeal.ii-dev/usr/share/deal.II/scripts/make_tarfile.sh
# Remove backup files
	rm -f debian/libdeal.ii-dev/usr/include/deal.II/base/config.h.in~
	touch $@

binary-indep: install build-doc
	dh_testdir -i
	dh_testroot -i
	dh_installdirs -i
#	dh_install -i
#	dh_movefiles -i
	dh_installdocs -i
	rm -rf debian/deal.ii-examples/usr/share/doc/deal.ii-examples/step-*/doc
# Fix example Makefiles
	for mfile in `ls debian/deal.ii-examples/usr/share/doc/deal.ii-examples/step-*/Makefile`; do \
	  mv $$mfile $$mfile.in; \
	  sed 's/$$D\/common/$$D/' < $$mfile.in | \
	    sed 's/$$D\/\*\/include/\/usr\/include\/deal.II/' | \
	    sed 's/$$D/\/usr\/share\/deal.II/' | \
	    sed 's/debug-mode = on/debug-mode = off/' | \
	    grep -v 'D = ' > $$mfile; \
	  rm -f $$mfile.in; \
	done
	dh_installchangelogs -i
	dh_compress -i -XMakefile -Xcc -Xinp
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_installdirs -a
#	dh_install -a
#	dh_movefiles -a
	install -d debian/libdeal.ii-dbg$(version)/usr/share/lintian/overrides
	install -m 644 debian/libdeal.ii-dbg$(version).overrides \
	  debian/libdeal.ii-dbg$(version)/usr/share/lintian/overrides/libdeal.ii-dbg$(version)
	dh_installdocs -a
	dh_installchangelogs -a
	dh_strip -a -X.g
	dh_makeshlibs -a
	dh_compress -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch

.PHONY: binary binary-arch binary-indep clean
